#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


FILE *fpin;
FILE *fpout;
double fps;

struct option{
	int o;
	int f;
};


int GetOpt(int argc, char *argv[], struct option *opt)
{
	for(int i = 2; i < argc; i++){
		if(!strcmp(argv[i], "-o")){
			i++;
			opt->o = i;
		}
		else if(!strcmp(argv[i], "-f")){
			i++;
			opt->f = i;
		}
		else
			return -1;
	}

	if(argc < 2 || opt->o == argc || opt->f == argc){
		return -1;
	}

	return 0;
}


void WriteChapter(double fnum)
{
	static int chnum;
	double sec;
	int hh, mm, ss, ms;


	if(chnum == 0 && fnum != 0)
		WriteChapter(0);

	chnum++;
	sec = fnum / fps;
	hh = (int)(sec / 3600);
	sec -= hh * 3600;
	mm = (int)(sec / 60);
	sec -= mm * 60;
	ss = (int)sec;
	ms = (int)ceil((sec - ss) * 1000);
	fprintf(fpout, "CHAPTER%02d=%02d:%02d:%02d.%03d\nCHAPTER%02dNAME=Chapter%2d\n", chnum, hh, mm, ss, ms, chnum, chnum);
}


void WriteCelltimes()
{
	char buf[14];
	double sec;
	int hh, mm, fnum;


	while(fscanf_s(fpin, "%[^=]=%d:%d:%lf", buf, 14, &hh, &mm, &sec) != EOF){
		if(strlen(buf) == 9){
			fnum = (int)((hh * 3600 + mm * 60 + sec) * fps);

			if(fnum != 0)
				fprintf(fpout, "%d\n", fnum);
		}
		else{
			while(int c = fgetc(fpin) != '\n'){
				if(c == EOF)
					return;
			}
		}
	}
}


void main(int argc, char *argv[])
{
	char buf[8], path[_MAX_PATH], drive[_MAX_DRIVE], dir[_MAX_DIR];
	double fnum;
	bool inch = 0;


	//IvV
	struct option opt = {0, 0};
	if(GetOpt(argc, argv, &opt)){
		printf("Usage:c2c.exe InputFile [-o OutputFile][-f FrameRate]\n");
		return;
	}


	//̓t@C
	if(fopen_s(&fpin, argv[1], "r")){ 
		fprintf(stderr, "File not found.\n");
		return;
	}

	fgets(buf, 8, fpin);
	if(!strncmp(buf, "CHAPTER", 7))
		inch = 1;


	//o̓t@C
	if(opt.o == 0){
		_splitpath_s(argv[1], drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, NULL, NULL, NULL);
		if(inch)
			sprintf_s(path, _MAX_PATH, "%s%scelltimes.txt", drive, dir);
		else
			sprintf_s(path, _MAX_PATH, "%s%schapter.txt", drive, dir);
	}
	else
		strcpy_s(path, argv[opt.o]);

	if(fopen_s(&fpout, path, "w")){
		fclose(fpin);
		fprintf(stderr, "Failed to create file.\n");
		return;
	}


	//t[[g
	if(opt.f == 0 || (fps = atof(argv[opt.f])) == 0)
		fps = 30000.0 / 1001;


	//t@C
	rewind(fpin);
	if(inch)
		WriteCelltimes();
	else{
		while(fscanf_s(fpin, "%lf", &fnum) == 1)
			WriteChapter(fnum);
	}

	fclose(fpin);
	fclose(fpout);
	return;
}